import {makeAutoObservable} from "mobx";
import {http} from "../utils/http";

export class Payback {
  page = 0;
  pageSize = 10;
  data = [];
  total_data = 0;
  filterCategory = null;
  visibleModalPayback = false;

  pagePaybackUser = 0;
  pageSizePaybackUser = 10;
  dataPaybackUser = [];
  total_dataPaybackUser = 0;

  constructor(ctx) {
    this.ctx = ctx;
    makeAutoObservable(this);
  }

  async getData() {
    try {
      const response = await http.get(
          `/transaction/deposit-return?page=${this.page}&pageSize=${this.pageSize}`
      );
      this.data = response.body.data.map((item, idx) => {
        item.key = idx;
        return item;
      }) ?? [];

      this.total_data = response.body.count ?? 0;
    } catch (e) {
      console.error(e);
    }
  }

  async getDataUser() {
    try {
      const response = await http.get(
          `/transaction/deposit-return/confirmation?page=${this.pagePaybackUser}&pageSize=${this.pageSizePaybackUser}`
      );
      this.dataPaybackUser = response.body.data.map((item, idx) => {
        item.key = idx;
        return item;
      }) ?? [];

      this.total_dataPaybackUser = response.body.count ?? 0;
    } catch (e) {
      console.error(e);
    }
  }

  async update(id, data) {
    try {
      const response = await http.put(`/config/commission/${id}`).send(data);
      await this.getData();
      return response;
    } catch (e) {
      console.error(e);
    }
  }

  async delete(id) {
    try {
      const response = await http.del(`/product/${id}`);
      await this.getData();
      return response;
    } catch (e) {
      console.error(e);
    }
  }

  async create(data) {
    try {
      const response = await http.post("/transaction/deposit-return").send(data);
      await this.getData();
      return response;
    } catch (e) {
      console.error(e);
    }
  }
}
